#!/bin/bash
#
# Elkesziti egy ev vagy egy honap statikus eredmenylapjat.
# kovacs.zoltan@mimoza.hu 2005-03-04
#

awstats_build="/usr/local/sbin/awstats/awstats_buildstaticpages.pl"
awstats_prog="/usr/lib/cgi-bin/awstats.pl"
LANGUAGE=hu

STATS_ROOT_DIR="$1"	# A statisztika alapkonyvtara
SRVNM="$2"		# A vizsglando hostname
YEAR="$3"		# A vizsgalt ev
MONTH="$4"		# A vizsgalt honap (elhagyasa eseten teljes ev)

###

# Ures parameterek kezelese. Honap elhagyasa az egesz evet jelenti.

if [ ! -z "$STATS_ROOT_DIR" -a ! -z "$SRVNM" -a ! -z "$YEAR" ]; then
    if [ -z "$MONTH" ] ; then
	MONTHALL="all"
    else
	MONTHALL=""
    fi

# Korabbi statikus lapok torlese, ha leteznek. Konyvtar letrehozasa, ha kell.

    mkdir -m 755 -p --verbose $STATS_ROOT_DIR/$SRVNM/$YEAR$MONTH
    rm -f $STATS_ROOT_DIR/$SRVNM/$YEAR$MONTH/*

# Elkeszulnek a statikus HTML lapok.

    $awstats_build \
	-config=$SRVNM \
	-lang=$LANGUAGE \
	-awstatsprog=$awstats_prog \
	-year=$YEAR \
	-month=$MONTH$MONTHALL \
	-dir=$STATS_ROOT_DIR/$SRVNM/$YEAR$MONTH \
	>/dev/null 2>&1

# Rossz parameterezes eseten emlekezteto.

else
    echo "Usage: $0 path_to_generate_rootdir servername year [month]"
fi
