#!/bin/bash
#
# Egyszeru script URL-ek mogotti webtartalom megletenek ellenorzesere.
# A wget spider uzemmodjanak kimenetet adja vissza.
# A website-manager csomag rsze.
# kovacs.zoltan@mimoza.hu 2007-02-06

EXIT_ERR="1"                                            # Exit code on error
EXIT_SUCC="0"                                           # Exit code on success
SED="/bin/sed"                                          # sed command call
URLCHECKAGENT="urlcheck-robot"                          # urlcheck browser agent name
URLCHECKTIMEOUT=30                                      # urlcheck default timeout (secs)
WGET="/usr/bin/wget"                                    # wget command call

MSG_WSM_URLCHECK_FATAL="000 Fatal!"

# Kozos beallitasok beolvasasa
HEADERS="/etc/default/website-manager"
. $HEADERS

# Parameterek atvetele
URL="$1"; shift				# Az ellenorzendo URL
TIMEOUT=${1:-$URLCHECKTIMEOUT}; shift	# Ennyi masodpercig var a dokumentum elerhetosegere

if [ ! -z "$URL" ] ; then
    START=`date '+%Y:%m:%d:%H:%M:%S'`
    RESULT=`$WGET "$URL" -nv --spider -U $URLCHECKAGENT -T $TIMEOUT 2>&1`
    END=`date '+%Y:%m:%d:%H:%M:%S'`
    if [ -z "$RESULT" ] ; then
        RESULT="$MSG_WSM_URLCHECK_FATAL"
    fi
    echo "$START $END $URL `echo $RESULT |  $SED -n 's/^.*\([[:digit:]]\{3\}\)\(:*\)\(.*$\)/\1\3/p'`"

# Rossz parameterezes eseten emlekezteto

else
    echo "Usage: $0 URL_to_check [ timeout_in_seconds ]"
    exit $EXIT_ERR
fi
