#!/bin/bash
#
# Egyszeru script az urlcheck kimenetek egyedi logokba torento szetosztasara.
# Erosen kihasznalja az urlcheck.sh kimeneti formatumat!
# A website-manager csomag resze.
# kovacs.zoltan@mimoza.hu 2007-02-06

APACHECOMMONLOG="ALLHOSTS"                              # Filename for common weblogs
APACHELOGDIR="/var/log/apache"                          # Root directory for Apache logs
AWK="/usr/bin/awk"                                      # awk command call
SED="/bin/sed"                                          # sed command call
URLCHECK_SUFFIX="-urlcheck.log"                         # suffix for urlcheck logs

# Kozos beallitasok beolvasasa.

HEADERS="/etc/default/website-manager"
. $HEADERS

# Standard inputrol beolvassa az urlcheck_scanhosts.sh kimenetet.

cat | while read LINE

# Minden sor bekerul a kozos logba.

do
    echo "$LINE" >> "$APACHELOGDIR/$APACHECOMMONLOG$URLCHECK_SUFFIX"

# Meghatarozza a hostnevet, es beteszi a sort a hosthoz tartozo logfile-ba.
# Az urlcheck.sh kimenet harmadik mezejet tekinti URL-nek, ebbol veszi ki a hostnevet.

    HOST=`echo "$LINE" | $AWK '{print $3}' | $SED "s/\(.*\:\/\/\)\(\(\([0-9a-zA-Z_-]\)\+\.\)\+\([0-9a-zA-Z]\)\+\)\(.*$\)/\2/"`
    if [ -f "$APACHELOGDIR/$HOST$URLCHECK_SUFFIX" ]; then
	echo "$LINE" >> "$APACHELOGDIR/$HOST$URLCHECK_SUFFIX"
    fi
done
