#!/bin/bash
#
# Egyszeru script az Apache-ban megadott virtualhostok folapjai elerhetosegenek tesztelesere.
# Hasznalhato explicit megadott URL-ek ellenorzesere, illetve webcron-knt is.
# A website-manager csomag resze.
# kovacs.zoltan@mimoza.hu 2007-02-06

APACHECONFIGDIR="/etc/apache/conf.d"                    # Directory for apache virtualhosts
AWK="/usr/bin/awk"                                      # awk command call
EXCEPTURL=""						# | delimited list - deprecated
EXIT_ERR="1"                                            # Exit code on error
EXIT_SUCC="0"                                           # Exit code on success
GREP="/bin/grep"                                        # grep command call
NOCHECK="NOCHECK"                          		# don't check exception token
OK="\( 200 (\)\|\( 200 OK\)"                    	# successfull urlcheck result code
SED="/bin/sed"                                          # sed command call
URLCHECK="/usr/local/sbin/urlcheck.sh"                  # urlcheck pathname
URLCHECK_EXC="/etc/apache/urlcheck.exception"           # urlcheck exceptions file pathname
URLCHECK_HOSTS="/etc/apache/urlcheck.hosts"             # urlcheck hosts file pathname
URLCHECKTIMEOUT=30                                      # urlcheck default timeout (secs)

MSG_WSM_URLCHECK_NOSCRIPT="Fatal: $URLCHECK isn't found!"

# Kozos beallitasok beolvasasa
HEADERS="/etc/default/website-manager"
. $HEADERS

# Hibaval kilep, ha nincs meg az ellenorzo script.

if [ ! -x "$URLCHECK" ]; then
    echo "$MSG_WSM_URLCHECK_NOSCRIPT" >&2
    exit $EXIT_ERR
fi

# Ha meg van adva a host lista, eloszor azokat ellenorzi, nem foglalkozik a kivetelekkel.
# A host lista soronkent egy servername-et tartalmaz, white space-ek nelkul.
# Ures sorok es # karakterrel kezdodo megjegyzes sorok  megengedettek.

if [ ! -z "`cat $URLCHECK_HOSTS 2>/dev/null | $AWK '{ if ($0 !~ /^#.*/) print $0 }' | $AWK 'NF > 0'`" ] ; then
    cat "$URLCHECK_HOSTS" | \
    $AWK '{ if ($0 !~ /^#.*/) print $0 }' | \
    $AWK 'NF > 0' | while read SRVNM
    do
        if [ -z "echo $SRVNM | $GREP '://'" ]; then 
    	    URL="http://$SRVNM" 
	else
	    URL="$SRVNM/"
	fi
	RESULT=`$URLCHECK $URL $URLCHECKTIMEOUT`

# Minden eredmeny megjelenik a standard kimeneten, a hibak a standard erroron is.

	echo $RESULT 
	echo $RESULT | $GREP -vi "$OK" >&2
    done
fi

# A kivetelek listaja soronkent egy servername-et es egy helyettesitot tartalmaz.
# Ures sorok es # karakterrel kezdodo megjegyzes sorok  megengedettek.

if [ -r "$URLCHECK_EXC" ] ; then
    EXCEPTURL=`echo -n $EXCEPTURL; cat $URLCHECK_EXC | \
	       $AWK '{ if ($0 !~ /^#.*/) print $0 }' | \
	       $AWK 'NF > 0' | while read LINE
	       do
	           echo "$LINE |"
	       done`
fi

# Ezutan vegignezi az Apache konfiguraciot, es kiszedi a virtualhostokat.
# Meghatarozza az URL-eket: ha az $EXCEPTURL-ben szerepelnek, csere kell.

$GREP -Rh "ServerName" $APACHECONFIGDIR | $GREP -v '#' | $SED -e "s/ServerName//" |while read SRVNM
do
    URL=`echo $EXCEPTURL | $AWK 'BEGIN { RS = "|" } ; { if ($1 == SRVNM) print $2 }' SRVNM=$SRVNM`
    if [ -z "$URL" ] ; then
	URL=$SRVNM
    fi

# A kizartak kivetelevel elvegzi az ellenorzest.

    if [ "$URL" != "$NOCHECK" ] ; then
	if [ -z "echo $URL | $GREP '://'" ]; then 
	    URL="http://$URL" 
	fi
	RESULT=`$URLCHECK $URL $TIMEOUT`

# Minden eredmeny megjelenik a standard kimeneten, a hibak a standard erroron is.

	echo $RESULT 
	echo $RESULT | $GREP -vi "$OK" >&2
    fi
done
