#!/bin/bash
#
# Egyszeru script Apache virtualhost konyvtar- es file jogok beallitasara.
# Nem bantja a root birtokaban levo (rendszerszintu hasznalatra megosztott) allomanyokat.
# kovacs.zoltan@mimoza.hu 2006-08-21

APACHEADMIN="webadmin"		# Default Linux user
APACHEGROUP="www-data"		# Default Linux group
APACHESHARE="root"		# System-wide shared content's default owner
RIGHTSFILE="640"		# File permissions: rw-r----- (640)
RIGHTSDIR="2750"		# Dir  permissions: rwxr-s--- (2750)
EXIT_ERR=1			# Exit code on error

# Including headers
HEADERS="/etc/default/website-manager"
. $HEADERS

# Messages
MSG_USAGE="Usage: $0 path_to_dir [user [group ]]\nUser defaults to $APACHEADMIN, group defaults to $APACHEGROUP\n"

# Directory is mandatory!
VHOST_ROOT_DIR=$1; shift
if [ ! -d "$VHOST_ROOT_DIR" ]; then echo -ne "$MSG_USAGE" >&2; exit $EXIT_ERR; fi

VHOST_USER=$1; shift
if [ -z "$VHOST_USER" ]; then VHOST_USER="$APACHEADMIN"; fi

VHOST_GROUP=$1; shift
if [ -z "$VHOST_GROUP" ]; then VHOST_GROUP="$APACHEGROUP"; fi

# Find and modify directories, files and symlinks (except $APACHESHARE owned)
find $VHOST_ROOT_DIR ! -user $APACHESHARE -type d -exec chown $VHOST_USER:$VHOST_GROUP {} \; -exec chmod $RIGHTSDIR {} \;
find $VHOST_ROOT_DIR ! -user $APACHESHARE -type f -exec chown $VHOST_USER:$VHOST_GROUP {} \; -exec chmod $RIGHTSFILE {} \;
find $VHOST_ROOT_DIR ! -user $APACHESHARE -type l -exec chown -h $VHOST_USER:$VHOST_GROUP {} \; 
